//+-------------------------------------------------------------------+
//|                                                        Aurora.mq4 |
//|                                  Copyright  2009, Steve Hopwood  |
//|                              http://www.hopwood3.freeserve.co.uk  |
//+-------------------------------------------------------------------+
#property copyright "Copyright  2009, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define  up "Up"
#define  down "Down"
#define  none "No tradable trend"

//D1 pivot and H4 open price
#define  vline "Period start line"
#define  hline "Open price line"
#define  pline "Daily pivot"

//Round number
#define  highline "Next high round number"
#define  lowline "Next low round number"

//ending trade price line
#define  pendingpriceline "Pending price line"

/*

This ea attempts to automate the strategy described at http://www.forexfactory.com/showthread.php?t=292877
I have no idea whether the ea can be successful.

Tools
5 minutes EURUSD chart
PWR
Candle range

Rules

PWR determines the trend, positive = bulish, negative = bearish
Do not trade when the candle is bigger than 15 pips

Long

PWR positive
Candle as a higher hi and higher low than the previous one.
Place a pending order at the high + spread with the stoploss on the candle's low and takeprofit at tha candle's size. R:R 1:1

Short
The exact opposite, of course.

Cancel your pending orders when they dont get hit after 3 candles.
After a order is activated no other order can be placed, until it hits tp or sl.


Trading times:
8.00 am to 18.00 pm Central European Time (CET) or London time +1 (GMT+1)


Matt Kennel has provided the code for bool O_R_CheckForHistory(int ticket). Cheers Matt, You are a star.



Code for adding debugging Sleep
Alert("G");
int x = 0;
while (x == 0) Sleep(100);

FUNCTIONS LIST
int init()
int start()

----Trading----

void LookForTradingOpportunities()
   void ShouldPendingBeCancelled()
   void HasBuyFilled()
   void HasSellFilled()
   double CalculateStopLoss(int type, double price)
   double CalculateTakeProfit(int type, double price)

bool IsTradingAllowed()
bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
bool DoesTradeExist()
bool CheckTradingTimes()
double CalculateLotSize(double price1, double price1)
void ShouldTradeClose()

----Trade direction----
void DrawLines()
void GetPivot()
void DrawPivot(double pivot)


----Matt's Order Reliable library code
bool O_R_CheckForHistory(int ticket) Cheers Matt, You are a star.
void O_R_Sleep(double mean_time, double max_time)

----Indicator readings----
void ReadIndicatorValues()
void GetPwr()
void CalculateAverageCandleLength()

----BIG NUMBERS MODULE----
void GetNextRoundNumbers()
void DrawLines(string name, double price, color col, int style, int width)
void DeleteLines()


*/

extern string  gen="----General inputs----";
extern double  Lot=0;//Leave at zero for the bot to calculate lot size by risk
extern int     StopLoss=0;//Only included as an options. Users should not set this as it overrides A's calculations
extern double  RiskPercent=1;
extern int     MagicNumber=0;
extern string  TradeComment="";
extern bool    CriminalIsECN=false;//Deleted extern as it should not be needed here.
extern double  MaxSpread=40;
extern int     PendingExpiryMinutes=15;

extern string  tpe="----Take profit inputs----";
extern int     TakeProfit=0;//Only included as an options. Users should not set this as it overrides A's calculations
extern bool    IncludeSpread=true;
extern int     TpPercentageOfSL=100;

extern string  sle="----Hiddend AL and TP inputs----";
extern int     HiddenPips=10;//Added to the 'hard' sl and tp and used for closure calculations

extern string  pwr="----PwR inputs----";
extern bool    MustBeContinuingTrend=true;

extern string  cri="----Candle Range inputs----";
extern int     MaxCandleRange=15;
extern string  acl="Average candle length";
extern int     LookBackForAverageCandles=264;

extern string  ie="----Dealing with 'invalid stop' errors----";
extern int     MaxNoOfRetries=60;//Max no of attemts A will make to send the trade
extern bool    SendMarketOrderIfAppropriate=true;//Tells A to send a market trade if the market exceeds the pending price

extern string  td="----Trading direction----";
extern bool    TradeLong=true;
extern bool    TradeShort=true;
extern bool    AutomateDirection=false;
extern string  tdl="H4 open price line";
extern bool    UseH4=false;
extern color   HorizontalLineColour=Turquoise;
extern color   VerticalLineColour=Turquoise;
extern int     TimeFrame=240;
extern string  D1="D1 Pivot";
extern bool    UsePivot=false;
extern int     PivotTimeFrame=1440;
extern bool    CriminalHasSundayCandle=true;
extern color   PivotLineColour=Blue;

extern string  tt="----Trading hours----";
extern string  Trade_Hours= "Set Morning & Evening Hours";
extern string  Trade_Hoursi= "Use 24 hour, local time clock";
extern string  Trade_Hours_M= "Morning Hours 0-12";
extern  int    start_hourm = 0;
extern  int    end_hourm = 12;
extern string  Trade_Hours_E= "Evening Hours 12-24";
extern  int    start_houre = 12;
extern  int    end_houre = 24;

extern string  lcs="----Round number lines----";
extern bool    UseRoundNumberFilter=true;
extern color   BuyLineColour=Yellow;
extern color   SellLineColour=Yellow;

extern string  mis="----Odds and ends----";
extern int     DisplayGapSize=30;

//Matt's O-R stuff
int 	         O_R_Setting_max_retries 	= 10;
double 	      O_R_Setting_sleep_time 		= 4.0; /* seconds */
double 	      O_R_Setting_sleep_max 		= 15.0; /* seconds */

//Trading variables
int            TicketNo, OpenTrades;
bool           CanTradeThisPair;//Will be false when this pair fails the currency can only trade twice filter, or the balanced trade filter
bool           BuyOpen, SellOpen;
string         direction;
string         swing;
bool           TradeExists;
   
//Pivot and H4 lines
int            OldLineBars, OldD1Bars;

//PwR
string         trend;
double         PwrDown, PwrUp;

//Candle range
double         CandleRange;
double         ConvertedCandleRange;//For entry, tp/sl purposes
double         AverageCandleLength;

//Margin status display
bool           EnoughMargin;
string         MarginMessage;

//Round numbers
double         RoundNumberHigh, RoundNumberLow;

//Pending price inputs. Keeps things hidden from the crims
bool           PendingBuy, PendingSell;
double         PendingPrice, PendingStop;
datetime       PendingTime;
double         PendingCandleRange;

//Misc
string         Gap, ScreenMessage;
int            OldBars;
string         PipDescription=" pips";
bool           ForceTradeClosure;
bool           InvalidStopError;//For dealing with invalid stops

void DisplayUserFeedback()
{
   
   if (IsTesting() && !IsVisualMode()) return;

   ScreenMessage = "";
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, TimeToStr(TimeLocal(), TIME_DATE|TIME_MINUTES|TIME_SECONDS), NL );
   /*
   //Code for time to bar-end display from Candle Time by Nick Bilak
   double i;
   int m,s,k;
   m=Time[0]+Period()*60-CurTime();
   i=m/60.0;
   s=m%60;
   m=(m-m%60)/60;
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, m + " minutes " + s + " seconds left to bar end", NL);
   */
      
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);      
   if (TradeLong) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Taking long trades",  NL);
   if (TradeShort) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Taking short trades",  NL);
   if (!TradeLong && !TradeShort) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Not trading",  NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Lot size: ", Lot, " (Criminal's minimum lot size: ", MarketInfo(Symbol(), MODE_MINLOT), ")", NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Take profit: ", TakeProfit, PipDescription,  NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Stop loss: ", StopLoss, PipDescription,  NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Magic number: ", MagicNumber, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trade comment: ", TradeComment, NL);
   if (CriminalIsECN) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "CriminalIsECN = true", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage,Gap, "CriminalIsECN = false", NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "MaxSpread = ", MaxSpread, ": Spread = ", MarketInfo(Symbol(), MODE_SPREAD), NL, NL );
   
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trading hours", NL);
   if (start_hourm == 0 && end_hourm == 12 && start_houre && end_houre == 24) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "            24H trading", NL);
   else
   {
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "            start_hourm: ", DoubleToStr(start_hourm, 2), 
                      ": end_hourm: ", DoubleToStr(end_hourm, 2), NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "            start_houre: ", DoubleToStr(start_houre, 2), 
                      ": end_houre: ", DoubleToStr(end_houre, 2), NL);
                      
   }//else
   
   
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "PwR direction: ", trend, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Previous candle range: ", CandleRange, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Average candle range over : ", AverageCandleLength, " pips, averaged over ", LookBackForAverageCandles, " candles", NL);

   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);

   if (UseRoundNumberFilter)
   {   
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Next high round number = ", DoubleToStr(RoundNumberHigh, Digits), NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Next low round number = ", DoubleToStr(RoundNumberLow, Digits), NL);
   }//   if (UseRoundNumberFilter)

   
   if (PendingBuy || PendingSell)
   {
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
      string type;
      if (PendingBuy) type = "Pending Buy at ";
      if (PendingSell) type = "Pending Sell at ";
      ScreenMessage = StringConcatenate(ScreenMessage,NL, Gap, type, DoubleToStr(PendingPrice, Digits), " set at ",
                                        TimeToStr(PendingTime, TIME_MINUTES), NL);      
   }//if (PendingBuy || PendingSell)
   
   
   if (MarginMessage != "") ScreenMessage = StringConcatenate(ScreenMessage,NL, Gap, MarginMessage, NL);

   
   Comment(ScreenMessage);


}//void DisplayUserFeedback()


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----

   //Adapt to x digit criminals
   int multiplier;
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   if(Digits == 6) multiplier = 100;   
   if(Digits == 7) multiplier = 1000;   
   
   if (multiplier > 1) PipDescription = " points";
   
   TakeProfit*= multiplier;
   StopLoss*= multiplier;
   HiddenPips*= multiplier;
   
   Gap="";
   if (DisplayGapSize > 0)
   {
      for (int cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }//if (DisplayGapSize >0)
   

   //Reset CriminIsECN if crim is IBFX and the punter does not know or, like me, keeps on forgetting
   string name = TerminalCompany();
   int ispart = StringFind(name, "IBFX", 0);
   if (ispart > -1) CriminalIsECN = true;
   
   if (TradeComment == "") TradeComment = " ";
   OldBars = Bars;
   ReadIndicatorValues();
   DisplayUserFeedback();
   
   //Call sq's show trades indi
   //iCustom(NULL, 0, "SQ_showTrades",Magic, 0,0);

   
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
   DeleteHiLoLines();
   ObjectDelete(pendingpriceline);
   
//----
   return(0);
}



bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
{
   
   
   int slippage = 10;
   if (Digits == 3 || Digits == 5) slippage = 100;
   
   color col = Red;
   if (type == OP_BUY || type == OP_BUYSTOP) col = Green;
   
   

   //Pending trades need to accommodate CriminalIsECN input
   if (!CriminalIsECN) int ticket = OrderSend(Symbol(),type, lotsize, price, slippage, stop, take, comment, MagicNumber, 0, col);
   
   //Is a 2 stage criminal - for market orders 
   if (CriminalIsECN)
   {
      bool result;
      int err;
      ticket = OrderSend(Symbol(),type, lotsize, price, slippage, 0, 0, comment, MagicNumber, 0, col);
      if (ticket > 0)
      {
	     
	     if (take > 0 && stop > 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           result = OrderModify(ticket, OrderOpenPrice(), stop, take, OrderExpiration(), CLR_NONE);
           if (!result)
           {
               err=GetLastError();
               Print(Symbol(), " SL/TP  order modify failed with error(",err,"): ",ErrorDescription(err));               
           }//if (!result)			  
        }//if (take > 0 && stop > 0)
      
	     if (take != 0 && stop == 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           result = OrderModify(ticket, OrderOpenPrice(), OrderStopLoss(), take, OrderExpiration(), CLR_NONE);
           if (!result)
           {
               err=GetLastError();
               Print(Symbol(), " SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
           }//if (!result)			  
        }//if (take == 0 && stop != 0)

        if (take == 0 && stop != 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           result = OrderModify(ticket, OrderOpenPrice(), stop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);
           if (!result)
           {
               err=GetLastError();
               Print(Symbol(), " SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
           }//if (!result)			  
        }//if (take == 0 && stop != 0)

      }//if (ticket > 0)
        
      
      
   }//if (CriminalIsECN)
   
   //Error trapping for both
   if (ticket < 0)
   {
      string stype;
      if (type == OP_BUY) stype = "OP_BUY";
      if (type == OP_SELL) stype = "OP_SELL";
      if (type == OP_BUYLIMIT) stype = "OP_BUYLIMIT";
      if (type == OP_SELLLIMIT) stype = "OP_SELLLIMIT";
      if (type == OP_BUYSTOP) stype = "OP_BUYSTOP";
      if (type == OP_SELLSTOP) stype = "OP_SELLSTOP";
      err=GetLastError();
      //Alert(Symbol(), " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
      Print(Symbol(), " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
      if (err == 130) InvalidStopError = true;
      return(false);
   }//if (ticket < 0)  
   
   if (ticket == -1) return(true);
   
   TicketNo = ticket;
   //Make sure the trade has appeared in the platform's history to avoid duplicate trades.
   //My mod of Matt's code attempts to overcome the bastard crim's attempts to overcome Matt's code.
   bool TradeReturnedFromCriminal = false;
   while (!TradeReturnedFromCriminal)
   {
      TradeReturnedFromCriminal = O_R_CheckForHistory(ticket);
      if (!TradeReturnedFromCriminal)
      {
         Alert(Symbol(), " sent trade not in your trade history yet. Turn of this ea NOW.");
      }//if (!TradeReturnedFromCriminal)
   }//while (!TradeReturnedFromCriminal)
   
   //Got this far, so trade send succeeded
   return(true);
   
}//End bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)

bool DoesTradeExist()
{
   
   TicketNo = -1;
   
   if (OrdersTotal() == 0) return(false);
   
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      
      if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
      {
         TicketNo = OrderTicket();
         return(true);         
      }//if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
   }//for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)

   return(false);

}//End bool DoesTradeExist()



bool IsTradingAllowed()
{
   //Returns false if any of the filters should cancel trading, else returns true to allow trading
   
   //Maximum candle size
   if (CandleRange > MaxCandleRange) return(false);
      
   //Maximum spread
   if (MarketInfo(Symbol(), MODE_SPREAD) > MaxSpread) return(false);
 
   
   //Must be higher hi-lo in a rising market, and lower hi-lo in a falling market
   if (trend == up)
   {
      if (High[1] < High[2]) return(false);
      if (Low[1] < Low[2]) return(false);
   }//if (trend == up)
   
   
   if (trend == down)
   {
      if (High[1] > High[2]) return(false);
      if (Low[1] > Low[2]) return(false);
   }//if (trend == down)
   
   //Must not have closed a trade in the same candle as the trigger candle
   if (OrdersHistoryTotal() > 0)
   {
      for (int cc = OrdersHistoryTotal() - 1; cc >= 0; cc--)
      {
         if (!OrderSelect(cc, SELECT_BY_POS, MODE_HISTORY) ) continue;
         if (OrderSymbol() != Symbol() ) continue;
         if (OrderMagicNumber() != MagicNumber) continue;
         if (OrderCloseTime() > Time[1]) return(false); 
      }//for (int cc = OrdersHistoryTotal() - 1; cc >= 0; cc--)
      
      
   }//if (OrdersHistoryTotal() > 0)
   
   
   return(true);


}//End bool IsTradingAllowed()

double CalculateLotSize(double price1, double price2)
{
   //Calculate the lot size by risk. Code kindly supplied by jmw1970. Nice one jmw.
   
   double FreeMargin = AccountFreeMargin();
   double TickValue = MarketInfo(Symbol(),MODE_TICKVALUE) ;
   double LotStep = MarketInfo(Symbol(),MODE_LOTSTEP);


   double SLPts = price1 - price2;
   SLPts/= Point;
   
   double Exposure = SLPts * TickValue; // Exposure based on 1 full lot

   double AllowedExposure = (FreeMargin * RiskPercent) / 100;
   
   int TotalSteps = ((AllowedExposure / Exposure) / LotStep);
   double LotSize = TotalSteps * LotStep;

   double MinLots = MarketInfo(Symbol(), MODE_MINLOT);
   double MaxLots = MarketInfo(Symbol(), MODE_MAXLOT);
   
   if (LotSize < MinLots) LotSize = MinLots;
   if (LotSize > MaxLots) LotSize = MaxLots;
   return(LotSize);

}//double CalculateLotSize(double price1, double price1)


double CalculateStopLoss(int type, double price)
{
   //Flexible stop loss calculation function
   double stop;
   
   if (type == OP_BUY)
   {
      stop = PendingStop;
      if (StopLoss > 0) stop = NormalizeDouble(price - (StopLoss * Point), Digits);
      //Add the hidden pips
      stop = NormalizeDouble(stop - (HiddenPips * Point), Digits);
   }//if (type == OP_BUY)


   if (type == OP_SELL)
   {
      stop = PendingStop;
      if (StopLoss > 0) stop = NormalizeDouble(price + (StopLoss * Point), Digits);
      //Add the hidden pips
      stop = NormalizeDouble(stop + (HiddenPips * Point), Digits);
   }//if (type == OP_SELL)



   return(stop);

}//End int CalculateStopLoss(int type, double price)

double CalculateTakeProfit(int type, double price)
{
   //Flexible take profit calculation function
   double take;
   double spread = MarketInfo(Symbol(), MODE_SPREAD) * Point;
   
   if (type == OP_BUY)
   {
      take = NormalizeDouble(price + ( ((PendingCandleRange * TpPercentageOfSL) / 100) * Point), Digits);
      if (IncludeSpread) take = NormalizeDouble(take + spread, Digits);
      
      //The user should not be using the next two lines, but I include them so that people have the flexibility
      if (TakeProfit > 0) take = NormalizeDouble(price + (TakeProfit * Point), Digits);
      
      //Add the hidden pips
      take = NormalizeDouble(take + (HiddenPips * Point), Digits);
   }//if (type == OP_BUY)


   if (type == OP_SELL)
   {
      take = NormalizeDouble(price - ( ((PendingCandleRange * TpPercentageOfSL) / 100) * Point), Digits);
      if (IncludeSpread) take = NormalizeDouble(take - spread, Digits);
      
      //The user should not be using the next two lines, but I include them so that people have the flexibility
      if (TakeProfit > 0) take = NormalizeDouble(price - (TakeProfit * Point), Digits);
      
      //Add the hidden pips
      take = NormalizeDouble(take - (HiddenPips * Point), Digits);
   }//if (type == OP_SELL)



   return(take);

}//End double CalculateTakeProfit(int type, double price)


void HasBuyFilled()
{
   //'Phantom' pending trade details are held in these variables.
   //bool           PendingBuy, PendingSell;
   //double         PendingPrice;
   //datetime       PendingTime;
   
   //This function examines the Bid to see if a pending Buy price has been reached, and sends the trade if so

   double take, stop, price;
   int type;
   double SendLot = Lot;
   
   RefreshRates();
   if (Ask >= PendingPrice)
   {
      price = Ask;
      type = OP_BUY;
      //Flexible stop loss calculator
      stop = CalculateStopLoss(OP_BUY, price); 
      //Flexible take profit calculator
      take = CalculateTakeProfit(OP_BUY, price);        

      //Round number filter. Open price and tp must both be below next high round number
      if(UseRoundNumberFilter)
      {
         if (price < RoundNumberHigh && take > RoundNumberHigh) 
         {
            PendingBuy = false;
            return;
         }//if (price < RoundNumberHigh && take > RoundNumberHigh) 
         
      }//if(UseRoundNumberFilter)

      //Calculate lots if user has opted for MM by leaving the input at zero
      if (Lot == 0)
      {
         //Needs to accommodate the hidden stop loss
         SendLot = CalculateLotSize(price, NormalizeDouble(stop + (HiddenPips * Point), Digits) );
      }//if (Lot = 0)
   
      //Check for minimum stop levels
      double StopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL) * Point;
      if (price - stop < StopLevel)
      {
         PendingBuy = false;
         return;
      }//if (price - stop < StopLevel)
      
      if (take - price < StopLevel)
      {
         PendingBuy = false;
         ObjectDelete(pendingpriceline);
         return;
      }//if (take - price < StopLevel)
      

      bool result = SendSingleTrade(type, TradeComment, SendLot, price, stop, take);
      if (result) 
      {
         ObjectDelete(pendingpriceline);
         PendingBuy = false;
      }//if (result) 
      
      
   }//if (Bid >= PendingPrice)
   

}//End void HasBuyFilled()

void HasSellFilled()
{
   //'Phantom' pending trade details are held in these variables.
   //bool           PendingBuy, PendingSell;
   //double         PendingPrice;
   //datetime       PendingTime;
   
   //This function examines the Bid to see if a pending Buy price has been reached, and sends the trade if so

   double take, stop, price;
   int type;
   double SendLot = Lot;
   
   RefreshRates();
   if (Bid <= PendingPrice)
   {
      price = Bid;
      type = OP_SELL;
      //Flexible stop loss calculator
      stop = CalculateStopLoss(OP_SELL, price); 
      //Flexible take profit calculator
      take = CalculateTakeProfit(OP_SELL, price);        

      //Round number filter. Open price and tp must both be above next low round number
      if(UseRoundNumberFilter)
      {
         if (price > RoundNumberLow && take < RoundNumberLow) 
         {
            PendingSell = false;
            ObjectDelete(pendingpriceline);
            return;
         }//if (price > RoundNumberLow && take < RoundNumberLow) 
         
      }//if(UseRoundNumberFilter)


      //Calculate lots if user has opted for MM by leaving the input at zero
      if (Lot == 0)
      {
         //Needs to accommodate the hidden stop loss
         SendLot = CalculateLotSize(NormalizeDouble(stop - (HiddenPips * Point), Digits), price);
      }//if (Lot = 0)

      bool result = SendSingleTrade(type, TradeComment, SendLot, price, stop, take);
      if (result) 
      {
         ObjectDelete(pendingpriceline);
         PendingSell = false;
      }//if (result) 
      
   }//if (Bid >= PendingPrice)
   

}//End void HasSellFilled()

void ShouldPendingBeCancelled()
{
   //Checks that the time has not run out for a 'pending' to 'fill'
   
   if (TimeCurrent() - PendingTime >= PendingExpiryMinutes * 60)
   {
      PendingBuy = false;
      PendingSell = false;
      ObjectDelete(pendingpriceline);
   }//if (TimeCurrent() - PendingTime >= PendingExpiryMinutes * 60)
     
   
}//End void ShouldPendingBeCancelled()


void LookForTradingOpportunities()
{

   RefreshRates();
   double take, stop, price;
   int type;
   bool SendTrade;
   double SendLot = Lot;
   
   //Check filters
   if (!IsTradingAllowed() ) return;
   
   double spread = MarketInfo(Symbol(), MODE_SPREAD) * Point;
   
   //The market direction, candle size and higher/lower hi-lo have all been checked prior to reaching this point, so
   //all that is needed is to enter in the direction of the trend.
   //Set up 'phantom' pendings where a 'normal' pending would have been sent, to hide the details from the crims
   
   //Long 
   if (trend == up && TradeLong)
   {
      if (PendingBuy) return;//No need to reset
      
      price = NormalizeDouble(High[1] + spread,Digits);
      
      PendingBuy = true;
      PendingSell = false;//Cancels existing pending sell
      PendingPrice = price;
      PendingTime = Time[0];
      PendingCandleRange = ConvertedCandleRange;
      PendingStop = Low[1];
      //Draw an up arrow
      string name = "arrow" + TimeCurrent();
      ObjectCreate(name, OBJ_ARROW, 0, TimeCurrent(), price);
      ObjectSet(name, OBJPROP_COLOR, Green);
      ObjectSet(name, OBJPROP_ARROWCODE, 241);
      
      //Look for immediate 'fill'
      HasBuyFilled();
      
   }//if (trend == up && TradeLong)
   
   
   //Short
   if (trend == down && TradeShort)
   {
      if (PendingSell) return;//No need to reset
      
      price = NormalizeDouble(Low[1] - spread,Digits);

      PendingBuy = false;//Cancels existing pending buy
      PendingSell = true;
      PendingPrice = price;
      PendingTime = Time[0];
      PendingCandleRange = ConvertedCandleRange;
      PendingStop = High[1];
      //Draw a down arrow
      name = "arrow" + TimeCurrent();
      ObjectCreate(name, OBJ_ARROW, 0, TimeCurrent(), price);
      ObjectSet(name, OBJPROP_COLOR, Red);
      ObjectSet(name, OBJPROP_ARROWCODE, 242);
      
      //Look for immediate 'fill'
      HasSellFilled();
   }//if (direction == down && TradeShort)
   

   //Draw a pending price line
   if (PendingBuy || PendingSell)
   {
      ObjectDelete(pendingpriceline);
      ObjectCreate(pendingpriceline, OBJ_HLINE, 0, TimeCurrent(), PendingPrice);
      ObjectSet(pendingpriceline, OBJPROP_COLOR, Green);
      ObjectSet(pendingpriceline, OBJPROP_WIDTH, 1);
      ObjectSet(pendingpriceline, OBJPROP_STYLE, STYLE_DASH);
         
   }//if (PendingBuy !! PendingSell)
   

}//void LookForTradingOpportunities()


////////////////////////////////////////////////////////////////////////////////////////////////
//Indicator module




/*
double CalculateVolatility(int period, int LookBack)
{
   //Calculates the volatility of a pair based on an average of their movement over LookBack periods
   
   double pips;
   for (int cc = 1; cc < LookBack; cc++)
   {
      pips+= iHigh(NULL, period, cc) - iLow(NULL, period, cc);      
   }//for (int cc = 1; cc < LookBack; cc++)
   
   pips/= LookBack;//Average pips movement per day
   //Alert(pips);

   //Convert to pips
   int multiplier;
   if (Digits == 2) multiplier = 10;
   if (Digits == 3) multiplier = 100;
   if (Digits == 4) multiplier = 1000;
   if (Digits == 5) multiplier = 10000;
   
   pips*= multiplier;
   int rpips = pips;//Convert to a simple integer - all we need
   
   return(rpips);
   
}//End double CalculateVolatility(int period, int LookBack)
*/




//End Indicator module
////////////////////////////////////////////////////////////////////////////////////////////////


bool CheckTradingTimes()
{
   int hour = TimeHour(TimeLocal() );
   
   if (end_hourm < start_hourm)
	{
		end_hourm += 24;
	}
	

	if (end_houre < start_houre)
	{
		end_houre += 24;
	}
	
	bool ok2Trade = true;
	
	ok2Trade = (hour >= start_hourm && hour <= end_hourm) || (hour >= start_houre && hour <= end_houre);

	// adjust for past-end-of-day cases
	// eg in AUS, USDJPY trades 09-17 and 22-06
	// so, the above check failed, check if it is because of this condition
	if (!ok2Trade && hour < 12)
	{
 		hour += 24;
		ok2Trade = (hour >= start_hourm && hour <= end_hourm) || (hour >= start_houre && hour <= end_houre);		
		// so, if the trading hours are 11pm - 6am and the time is between  midnight to 11am, (say, 5am)
		// the above code will result in comparing 5+24 to see if it is between 23 (11pm) and 30(6+24), which it is...
	}


   // check for end of day by looking at *both* end-hours

   if (hour >= MathMax(end_hourm, end_houre))
   {      
      ok2Trade = false;
   }//if (hour >= MathMax(end_hourm, end_houre))

   return(ok2Trade);

}//bool CheckTradingTimes()


//=============================================================================
//                           O_R_CheckForHistory()
//
//  This function is to work around a very annoying and dangerous bug in MT4:
//      immediately after you send a trade, the trade may NOT show up in the
//      order history, even though it exists according to ticket number.
//      As a result, EA's which count history to check for trade entries
//      may give many multiple entries, possibly blowing your account!
//
//  This function will take a ticket number and loop until
//  it is seen in the history.
//
//  RETURN VALUE:
//     TRUE if successful, FALSE otherwise
//
//
//  FEATURES:
//     * Re-trying under some error conditions, sleeping a random
//       time defined by an exponential probability distribution.
//
//     * Displays various error messages on the log for debugging.
//
//  ORIGINAL AUTHOR AND DATE:
//     Matt Kennel, 2010
//
//=============================================================================
bool O_R_CheckForHistory(int ticket)
{
   //My thanks to Matt for this code. He also has the undying gratitude of all users of my trading robots
   
   int lastTicket = OrderTicket();

   int cnt = 0;
   int err = GetLastError(); // so we clear the global variable.
   err = 0;
   bool exit_loop = false;
   bool success=false;

   while (!exit_loop) {
      /* loop through open trades */
      int total=OrdersTotal();
      for(int c = 0; c < total; c++) {
         if(OrderSelect(c,SELECT_BY_POS,MODE_TRADES) == true) {
            if (OrderTicket() == ticket) {
               success = true;
               exit_loop = true;
            }
         }
      }
      if (cnt > 3) {
         /* look through history too, as order may have opened and closed immediately */
         total=OrdersHistoryTotal();
         for(c = 0; c < total; c++) {
            if(OrderSelect(c,SELECT_BY_POS,MODE_HISTORY) == true) {
               if (OrderTicket() == ticket) {
                  success = true;
                  exit_loop = true;
               }
            }
         }
      }

      cnt = cnt+1;
      if (cnt > O_R_Setting_max_retries) {
         exit_loop = true;
      }
      if (!(success || exit_loop)) {
         Print("Did not find #"+ticket+" in history, sleeping, then doing retry #"+cnt);
         O_R_Sleep(O_R_Setting_sleep_time, O_R_Setting_sleep_max);
      }
   }
   // Select back the prior ticket num in case caller was using it.
   if (lastTicket >= 0) {
      OrderSelect(lastTicket, SELECT_BY_TICKET, MODE_TRADES);
   }
   if (!success) {
      Print("Never found #"+ticket+" in history! crap!");
   }
   return(success);
}//End bool O_R_CheckForHistory(int ticket)

//=============================================================================
//                              O_R_Sleep()
//
//  This sleeps a random amount of time defined by an exponential
//  probability distribution. The mean time, in Seconds is given
//  in 'mean_time'.
//  This returns immediately if we are backtesting
//  and does not sleep.
//
//=============================================================================
void O_R_Sleep(double mean_time, double max_time)
{
   if (IsTesting()) {
      return;   // return immediately if backtesting.
   }

   double p = (MathRand()+1) / 32768.0;
   double t = -MathLog(p)*mean_time;
   t = MathMin(t,max_time);
   int ms = t*1000;
   if (ms < 10) {
      ms=10;
   }
   Sleep(ms);
}//End void O_R_Sleep(double mean_time, double max_time)


///////////////////////////////////////////////////////////////////////////////////////////////////////

void AutoTradeDirectionDetection()
{
   TradeLong = false;
   TradeShort = false;
   bool long = true, short = true;
   
   //H4 open price
   if (UseH4)
   {
      double target = ObjectGet(hline, OBJPROP_PRICE1);
      if (Bid < target) long = false;
      if (Bid > target) short = false;
   }//UseH4
   
   //D1 pivot
   if (UsePivot)
   {
      target = ObjectGet(pline, OBJPROP_PRICE1);
      if (Bid < target) long = false;
      if (Bid > target) short = false;
   }//if (UseD1Pivot)

   if (long) TradeLong = true;
   if (short) TradeShort = true;
   
   
}//void AutomaticTradeDirectionDetection()

///////////////////////////////////////////////////////////////////////////////////////////////////////
//INDICATOR MODULE

void DrawLines()
{
   ObjectDelete(vline);
   ObjectDelete(hline);
   
   ObjectCreate(vline,OBJ_VLINE,0,iTime(NULL, TimeFrame, 0), 0);
   ObjectSet(vline,OBJPROP_COLOR,VerticalLineColour);
   ObjectSet(vline,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet(vline,OBJPROP_WIDTH,1);    

   ObjectCreate(hline,OBJ_HLINE,0,TimeCurrent(), iOpen(NULL, TimeFrame, 0) );
   ObjectSet(hline,OBJPROP_COLOR,HorizontalLineColour);
   ObjectSet(hline,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet(hline,OBJPROP_WIDTH,1);    


}//void DrawLines()

void GetPivot()
{
   int day = TimeDayOfWeek(TimeCurrent() );
   int shift = 1;
   if (PivotTimeFrame == PERIOD_D1 && day == 1 && CriminalHasSundayCandle) shift = 2;//Deal with the Sunday cabdle
   
   //double pivot = NormalizeDouble((iHigh(NULL, PivotTimeFrame, shift) + iLow(NULL, PivotTimeFrame, shift)) / 2, Digits);
   double pivot = NormalizeDouble((iHigh(NULL, PivotTimeFrame, shift) + iLow(NULL, PivotTimeFrame, shift) + iClose(NULL, PivotTimeFrame, shift)) / 3, Digits);
   DrawPivot(pivot);
}//void GetPivot()


void DrawPivot(double pivot)
{

   ObjectDelete(pline);
   
   ObjectCreate(pline,1,0,TimeCurrent(), pivot);
   ObjectSet(pline,OBJPROP_COLOR,PivotLineColour);
   ObjectSet(pline,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet(pline,OBJPROP_WIDTH,1);    

}//void DrawPivot(double pivot)

void GetPwr()
{
   //Reads the PwR custom indi and selects a trend based on the return.
   //Or did, until John intervened with this code. Fabulous John. Thanks.
   
   
   //PwrDown = iCustom(NULL, 0, "PwR", 2, 1);
   //PwrUp = iCustom(NULL, 0, "PwR", 1, 1);
   double ld_power = iBearsPower(NULL,0,144,PRICE_CLOSE,1) + iBullsPower(NULL,0,144,PRICE_CLOSE,1);
   
   trend = none;
   
   if (ld_power > 0) trend = up;
   if (ld_power < 0) trend = down;
   
   /*
   if (PwrDown != EMPTY_VALUE)
   {
      trend = down;
   }//if (PwrDown != EMPTY_VALUE)
   
   if (PwrUp != EMPTY_VALUE)
   {
      trend = up;
   }//if (PwrDown != EMPTY_VALUE)
   */
   //Check that histos are still moving in the right direction
   if (MustBeContinuingTrend)
   {
      double prev_ld_power = iBearsPower(NULL,0,144,PRICE_CLOSE,2) + iBullsPower(NULL,0,144,PRICE_CLOSE,2);
         
      if (trend == up)
      {
         //double PrevPwrUp = iCustom(NULL, 0, "PwR", 1, 2);
         //if (PrevPwrUp >= PwrUp) trend = none;
         if (prev_ld_power >= ld_power) trend = none;
      }//if (trend == up)
      
      if (trend == down)
      {
         //double PrevPwrDown = iCustom(NULL, 0, "PwR", 2, 2);
         //if (PrevPwrDown <= PwrDown) trend = none;
         if (prev_ld_power <= ld_power) trend = none;
      }//if (trend == down)
      
   }//if (MustBeContinuingTrend)
   
   
}//End void GetPwr()


void GetCandleRange()
{
   //Reads the Candle_Range_in_pips indi for the size of the previous candle. I could hand-code this, but using
   //the indi saves me having to do the conversion of x.xxxx to an integer - something I usually bugger up
   
   CandleRange = iCustom(NULL, 0, "Candle_Range_in_pips", 0, 1);

   int multiplier;
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   if(Digits == 6) multiplier = 100;   
   if(Digits == 7) multiplier = 1000;   

   ConvertedCandleRange = CandleRange * multiplier;
   
}//void GetCandleRange()

void CalculateAverageCandleLength()
{
   //Looks back over the past LookBackForAverageCandles to calculate their average length
//AverageCandleLength   

   double pips;
   for (int cc = 1; cc < LookBackForAverageCandles; cc++)
   {
      pips+= (High[cc] - Low[cc]);
   }//for (int cc = 1; cc < LookBackForAverageCandles; cc++)

   pips = pips / LookBackForAverageCandles;

   //Convert to pips
   int multiplier;
   if (Digits == 2) multiplier = 100;
   if (Digits == 3) multiplier = 100;
   if (Digits == 4) multiplier = 10000;
   if (Digits == 5) multiplier = 10000;

   pips = NormalizeDouble(pips * multiplier, 1);
   AverageCandleLength = pips;
   
}//End void CalculateAverageCandleLength()

void ReadIndicatorValues()
{

   GetNextRoundNumbers();
   CalculateAverageCandleLength();
   GetCandleRange();
   GetPwr();
   
}//void ReadIndicatorValues()

//END INDICATOR MODULE
///////////////////////////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////////////////////////
//BIG NUMBERS MODULE

void GetNextRoundNumbers()
{
   //Finds the nearest big numbers to the market price.
   //Saves these in RoundNumberHigh[index] and RoundNumberLow[index]
   
   RefreshRates();
   
   //Jpy pairs
   if (Digits == 2 || Digits == 3)
   {
      int price = Ask;//Truncates the quote
      RoundNumberLow = price;
      RoundNumberHigh = price + 1;
      
            
   }//if (Digits == 2 || Digits == 3)

   //non-Jpy pairs
   if (Digits == 4 || Digits == 5)
   {      
      string sprice = DoubleToStr(Ask, Digits);
      if (Ask >= 10) sprice = StringSubstr(sprice, 0, 5);       
      if (Ask < 10) sprice = StringSubstr(sprice, 0, 4);       
      RoundNumberLow = StrToDouble(sprice);
      RoundNumberHigh = RoundNumberLow + 0.01;      
   }//if (Digits == 4 || Digits == 5)

   

   //Draw the lines
   double hl, ll;//Hi-lo lines
   hl = ObjectGet(highline, OBJPROP_PRICE1);
   ll = ObjectGet(lowline, OBJPROP_PRICE1);
   
   if (Bid > hl || Bid < ll)
   {
      DeleteHiLoLines();
      DrawHiLoLines(highline, RoundNumberHigh, BuyLineColour, STYLE_SOLID, 1);
      DrawHiLoLines(lowline, RoundNumberLow, SellLineColour, STYLE_SOLID, 1);
   }//if (Bid > hl || Bid < ll)
   
   
}//End void GetNextRoundNumbers()

void DeleteHiLoLines()
{
   ObjectDelete(highline);
   ObjectDelete(lowline);
   
}//void DeleteLines()


void DrawHiLoLines(string name, double price, color col, int style, int width)
{

   ObjectDelete(name);
   

   ObjectCreate(name, OBJ_HLINE, 0, TimeCurrent(), price);
   ObjectSet(name, OBJPROP_COLOR, col);
   ObjectSet(name, OBJPROP_WIDTH, width);
   ObjectSet(name, OBJPROP_STYLE, style);
   ObjectSet(name, OBJPROP_RAY, false);
   
   
}//End void DrawLines(string name, double price, color col, int style, int type

//END BIG NUMBERS MODULE
///////////////////////////////////////////////////////////////////////////////////////////////////////

void ShouldTradeClose()
{
   //Examines the hidden sl/tp for possible trade closure
   
   if (!OrderSelect(TicketNo, SELECT_BY_TICKET) || OrderCloseTime() > 0) return;
   
   double target;
   bool CloseTrade = false;
   
   if (OrderType() == OP_BUY)
   {
      //TP
      target = NormalizeDouble(OrderTakeProfit() - (HiddenPips * Point), Digits);
      if (Bid >= target) CloseTrade = true;
      //SL
      target = NormalizeDouble(OrderStopLoss() + (HiddenPips * Point), Digits);
      if (Bid <= target) CloseTrade = true;
   }//if (OrderType() == OP_BUY)
   
   if (OrderType() == OP_SELL)
   {
      //TP
      target = NormalizeDouble(OrderTakeProfit() + (HiddenPips * Point), Digits);
      if (Bid <= target) CloseTrade = true;
      //SL
      target = NormalizeDouble(OrderStopLoss() - (HiddenPips * Point), Digits);
      if (Bid >= target) CloseTrade = true;
   }//if (OrderType() == OP_SELL
   
   if (CloseTrade) OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 10000, Blue);

}//End void ShouldTradeClose()


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----

   ///////////////////////////////////////////////////////////////////////////////////////////////////////   
   //Look for opportunity to 'fill' a 'pending' trade. These are 'phantom' trades held in the variables:
   //bool           PendingBuy, PendingSell;
   //double         PendingPrice;
   //datetime       PendingTime;
   
   //Look for time run out conditions
   if (PendingBuy || PendingSell) ShouldPendingBeCancelled();
   
   if (PendingBuy)
   {  
      HasBuyFilled();
   }//if (PendingBuy)
   
   if (PendingSell)
   {
      HasSellFilled();
   }//if (PendPendingSellngBuy)
   
   
   ///////////////////////////////////////////////////////////////////////////////////////////////////////

   
   //Deal with the market moving outside current round number lines
   if(UseRoundNumberFilter && (Ask > RoundNumberHigh || Bid < RoundNumberLow)) GetNextRoundNumbers();

   ///////////////////////////////////////////////////////////////////////////////////////////////
   if (AutomateDirection) 
   {
      //H4 opend price and daily pivot lines
      if (OldLineBars != iBars(NULL, TimeFrame) && UseH4)
      {
         OldLineBars = iBars(NULL, TimeFrame);
         DrawLines();
      }//if (OldLineBars != iBars(NULL, TimeFrame)
   
      if (OldD1Bars != iBars(NULL, PERIOD_D1) && UsePivot)
      {
         GetPivot();
         OldD1Bars = iBars(NULL, PERIOD_D1);
      }//if (OldD1Bars != iBars(NULL, PERIOD_D1) )
   
   
      AutoTradeDirectionDetection();
   }//if (AutomateDirection) 
   
   ///////////////////////////////////////////////////////////////////////////////////////////////
   //Find open trades.   
   TradeExists = DoesTradeExist();
   if (TradeExists)
   {
       PendingBuy = false;//Just in case
       PendingSell = false;//Just in case   
       ShouldTradeClose();    
   }//if (TradeExists)
   
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   //Trading times
   bool TradeTimeOk = CheckTradingTimes();
   if (!TradeTimeOk)
   {
      Comment("Outside trading hours\nstart_hourm-end_hourm: ", start_hourm, "-",end_hourm, "\nstart_houre-end_houre: ", start_houre, "-",end_houre);
      return;
   }//if (hour < start_hourm)
  
   ///////////////////////////////////////////////////////////////////////////////////////////////         
   //Trading
   if (OldBars != Bars)
   {
      OldBars = Bars;
      ReadIndicatorValues();
      if (TicketNo == -1)
      {   
         LookForTradingOpportunities();
      }//if (TicketNo == -1)
   }//if (OldBars != Bars)
   
   ///////////////////////////////////////////////////////////////////////////////////////////////      

   DisplayUserFeedback();
   
//----
   return(0);
}
//+------------------------------------------------------------------+