//+------------------------------------------------------------------+
//|                                                     BarClock.mq4 |
//|                                 Originally by Jerome (Clock.mq4) |
//|                                             Modified by brucehvn |
//+------------------------------------------------------------------+
#property copyright "brucehvn"
#property link      "bhweb@speakeasy.net"

//------------------------------------------------------------------
// Instructions
//    BrokerTZ  - Timezone of your Broker (in hours from GMT)
//    LocalTz   - Your timezone in hours from GMT
//    DST       - Is it daylight savings time?
//    ShowLocal - Set to tru to show your local time zone
//    corner    - 0 = top left, 1 = top right, 2 = bottom left, 3 = bottom right
//    topOff    - pixels from top to show the clock
//    labelColor- Color of label
//    clockColor- Color of clock
//
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red


//---- input parameters
extern int corner = 0;
extern int topOff = 75;
extern int xoff = 75;
extern int yoff = 75;
extern color labelColor = DodgerBlue;
extern color clockColor = Red;
extern bool ShowServerTime = true;

//---- buffers
double ExtMapBuffer1[];

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
    int counted_bars = IndicatorCounted();
//----
    double dSpreadValue = MarketInfo(Symbol(), MODE_SPREAD);
    string dspreadt   = StringConcatenate(" ", dSpreadValue);

   
    ObjectSetText( "spreadl", "Spread:", 10, "Arial", labelColor );
    ObjectSetText( "spreadt", dspreadt, 10, "Arial", clockColor );    
 

//----
    return( 0 );
}

//+------------------------------------------------------------------+

int init() {
//---- indicators

    ObjectDelete( "spreadl" );    
    ObjectDelete( "spreadt" );    

    SetIndexStyle( 0, DRAW_LINE );
    SetIndexBuffer( 0, ExtMapBuffer1 );

    int top = topOff;



    ObjectMakeLabel( "spreadl", 5, top - 65 );
    ObjectMakeLabel( "spreadt", 60, top - 65 );    
    
//----
    return( 0 );
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
//----
    ObjectDelete( "brol" );
    ObjectDelete( "brot" );
    ObjectDelete( "barl" );
    ObjectDelete( "bart" );
//----
    return( 0 );
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int ObjectMakeLabel( string n, int xoff, int yoff ) {
    ObjectCreate( n, OBJ_LABEL, 0, 0, 0 );
    ObjectSet( n, OBJPROP_CORNER, corner );
    ObjectSet( n, OBJPROP_XDISTANCE, xoff );
    ObjectSet( n, OBJPROP_YDISTANCE, yoff );
    ObjectSet( n, OBJPROP_BACK, true );
}




