//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Blue
#property indicator_color3  PaleVioletRed
#property indicator_color4  Gold
#property indicator_color5  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  3
#property indicator_width5  3
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern string RsiTimeFrame1       = "c+1";
extern int    RsiPeriod1          = 2;
extern int    RsiPrice1           = PRICE_CLOSE;
extern string RsiTimeFrame2       = "c+2";
extern int    RsiPeriod2          = 2;
extern int    RsiPrice2           = PRICE_CLOSE;
extern string RsiTimeFrame3       = "c+3";
extern int    RsiPeriod3          = 2;
extern int    RsiPrice3           = PRICE_CLOSE;
extern double LevelUp             = 93;
extern double LevelDown           =  7;
extern bool   Interpolate         = true;

//
//
//
//
//

extern bool alertsOnLevelsBreak   = false;
extern bool alertsOnLevelsRetrace = false;
extern bool alertsOn50Align       = true;
extern bool alertsOn              = false;
extern bool alertsOnCurrent       = true;
extern bool alertsMessage         = true;
extern bool alertsSound           = false;
extern bool alertsEmail           = false;

//
//
//
//
//

double rsi1[];
double rsi2[];
double rsi3[];
double arrowMidUp[];
double arrowMidDn[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame1;
int    timeFrame2;
int    timeFrame3;
bool   returnBars;

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,rsi1);
   SetIndexBuffer(1,rsi2);
   SetIndexBuffer(2,rsi3);
   SetIndexBuffer(3,arrowMidUp); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);
   SetIndexBuffer(4,arrowMidDn); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,159);
   
   //
   //
   //
   //
   //
   
      indicatorFileName = WindowExpertName();
      returnBars        = (RsiTimeFrame1=="returnBars"); if (returnBars) return(0);
            timeFrame1  = getTimeFrame(RsiTimeFrame1); 
            timeFrame2  = getTimeFrame(RsiTimeFrame2);
            timeFrame3  = getTimeFrame(RsiTimeFrame3);
               SetLevelValue(0,LevelUp);   
               SetLevelValue(1,LevelDown);   
               SetLevelValue(2,50);   
      
   //
   //
   //
   //
   //
      
   IndicatorShortName(timeFrameToString(timeFrame1)+" rsi ("+RsiPeriod1+") - "+
                      timeFrameToString(timeFrame2)+" rsi ("+RsiPeriod2+") - "+
                      timeFrameToString(timeFrame3)+" rsi ("+RsiPeriod3+")");
   return(0);
}
int deinit()
{
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double trends[][7];
#define trendm1 0
#define trendm2 1
#define trendm3 2
#define trendl1 3
#define trendl2 4
#define trendl3 5
#define trendmm 6

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { rsi1[0] = limit+1; return(0); }
         if (ArrayRange(trends,0)!=Bars) ArrayResize(trends,Bars);
   
   //
   //
   //
   //
   //
    
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame1,indicatorFileName,"returnBars",0,0)*timeFrame1/Period()));
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame2,indicatorFileName,"returnBars",0,0)*timeFrame2/Period()));
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame3,indicatorFileName,"returnBars",0,0)*timeFrame3/Period()));
      for(i=limit,r=Bars-i-1; i >= 0; i--,r++)
      {
         int y1 = iBarShift(NULL,timeFrame1,Time[i]); rsi1[i] = iRSI(NULL,timeFrame1,RsiPeriod1,RsiPrice1,y1); setTrends(rsi1,trendm1,trendl1,i);
         int y2 = iBarShift(NULL,timeFrame2,Time[i]); rsi2[i] = iRSI(NULL,timeFrame2,RsiPeriod2,RsiPrice2,y2); setTrends(rsi2,trendm2,trendl2,i);
         int y3 = iBarShift(NULL,timeFrame3,Time[i]); rsi3[i] = iRSI(NULL,timeFrame3,RsiPeriod3,RsiPrice3,y3); setTrends(rsi3,trendm3,trendl3,i);
            
            //
            //
            //
            //
            //
            
            arrowMidUp[i] = EMPTY_VALUE;
            arrowMidDn[i] = EMPTY_VALUE;
               trends[r][trendmm] = trends[r][trendm1]+trends[r][trendm2]+trends[r][trendm3];
                  if (trends[r][trendmm]== 3 && trends[r-1][trendmm]!= 3) arrowMidUp[i]=MathMin(MathMin(rsi1[i],rsi2[i]),rsi3[i])-1;
                  if (trends[r][trendmm]==-3 && trends[r-1][trendmm]!=-3) arrowMidDn[i]=MathMax(MathMax(rsi1[i],rsi2[i]),rsi3[i])+1;
            
            //
            //
            //
            //
            //
            
            if (!Interpolate) continue;
         if (y1 != iBarShift(NULL,timeFrame1,Time[i-1])) interpolate(rsi1,iTime(NULL,timeFrame1,y1),i);
         if (y2 != iBarShift(NULL,timeFrame2,Time[i-1])) interpolate(rsi2,iTime(NULL,timeFrame2,y2),i);
         if (y3 != iBarShift(NULL,timeFrame3,Time[i-1])) interpolate(rsi3,iTime(NULL,timeFrame3,y3),i);
      }
   
   //
   //
   //
   //
   //
   
   manageAlerts();
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
// 
//
//

void setTrends(double& rsi[], int trendm,int trendl, int i)
{
   int r = Bars-i-1;
   trends[r][trendm] = trends[r-1][trendm];
   trends[r][trendl] = trends[r-1][trendl];
      if (rsi[i]>LevelUp)                     trends[r][trendl] = -1;
      if (rsi[i]<LevelDown)                   trends[r][trendl] = -1;
      if (rsi[i]<LevelUp && rsi[i]>LevelDown) trends[r][trendl] =  0;
      if (rsi[i]>50)                          trends[r][trendm] =  1;
      if (rsi[i]<50)                          trends[r][trendm] = -1;
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
// 
//
//

void interpolate(double& buffer[], datetime time, int i)
{
   for (int n = 1; (i+n) < Bars && Time[i+n] >= time; n++) continue;
   
   //
   //
   //
   //
   //
   
   if (buffer[i] == EMPTY_VALUE || buffer[i+n] == EMPTY_VALUE) n=-1;
               double increment = (buffer[i+n] - buffer[i])/ n;
   for (int k = 1; k < n; k++)     buffer[i+k] = buffer[i] + k*increment;
}



//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      if (alertsOnLevelsBreak || alertsOnLevelsRetrace)
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            int tfBar  = iBarShift(NULL,0,iTime(NULL,timeFrame1,whichBar));
            int forBar = Bars-whichBar-1;      
            
            if (alertsOnLevelsBreak)
            {
               if (trends[forBar][trendl1] ==  1 && trends[forBar-1][trendl1] !=  1) doAlert(time1,mess1,tfBar,"rsi "+timeFrameToString(timeFrame1)+" broke level "+DoubleToStr(LevelUp,2)+" up");
               if (trends[forBar][trendl1] == -1 && trends[forBar-1][trendl1] != -1) doAlert(time1,mess1,tfBar,"rsi "+timeFrameToString(timeFrame1)+" broke level "+DoubleToStr(LevelDown,2)+" down");
            }               
            if (alertsOnLevelsBreak)
            {
               if (trends[forBar][trendl1] !=  1 && trends[forBar-1][trendl1] ==  1) doAlert(time1,mess1,tfBar,"rsi "+timeFrameToString(timeFrame1)+" retraced from "+DoubleToStr(LevelUp,2)+" down");
               if (trends[forBar][trendl1] != -1 && trends[forBar-1][trendl1] == -1) doAlert(time1,mess1,tfBar,"rsi "+timeFrameToString(timeFrame1)+" retraced from "+DoubleToStr(LevelDown,2)+" up");
            }

         //
         //
         //
         //
         //

         static datetime time2 = 0;
         static string   mess2 = "";
            tfBar  = iBarShift(NULL,0,iTime(NULL,timeFrame2,whichBar));
            forBar = Bars-whichBar-1;
            
            if (alertsOnLevelsBreak)
            {
               if (trends[forBar][trendl2] ==  1 && trends[forBar-1][trendl2] !=  1) doAlert(time2,mess2,tfBar,"rsi "+timeFrameToString(timeFrame2)+" broke level "+DoubleToStr(LevelUp,2)+" up");
               if (trends[forBar][trendl2] == -1 && trends[forBar-1][trendl2] != -1) doAlert(time2,mess2,tfBar,"rsi "+timeFrameToString(timeFrame2)+" broke level "+DoubleToStr(LevelDown,2)+" down");
            }               
            if (alertsOnLevelsBreak)
            {
               if (trends[forBar][trendl2] !=  1 && trends[forBar-1][trendl2] ==  1) doAlert(time2,mess2,tfBar,"rsi "+timeFrameToString(timeFrame2)+" retraced from "+DoubleToStr(LevelUp,2)+" down");
               if (trends[forBar][trendl2] != -1 && trends[forBar-1][trendl2] == -1) doAlert(time2,mess2,tfBar,"rsi "+timeFrameToString(timeFrame2)+" retraced from "+DoubleToStr(LevelDown,2)+" up");
            }

         //
         //
         //
         //
         //

         static datetime time3 = 0;
         static string   mess3 = "";
            tfBar  = iBarShift(NULL,0,iTime(NULL,timeFrame3,whichBar));
            forBar = Bars-whichBar-1;
            
            if (alertsOnLevelsBreak)
            {
               if (trends[forBar][trendl3] ==  1 && trends[forBar-1][trendl3] !=  1) doAlert(time3,mess3,tfBar,"rsi "+timeFrameToString(timeFrame3)+" broke level "+DoubleToStr(LevelUp,2)+" up");
               if (trends[forBar][trendl3] == -1 && trends[forBar-1][trendl3] != -1) doAlert(time3,mess3,tfBar,"rsi "+timeFrameToString(timeFrame3)+" broke level "+DoubleToStr(LevelDown,2)+" down");
            }               
            if (alertsOnLevelsBreak)
            {
               if (trends[forBar][trendl3] !=  1 && trends[forBar-1][trendl3] ==  1) doAlert(time3,mess3,tfBar,"rsi "+timeFrameToString(timeFrame3)+" retraced from "+DoubleToStr(LevelUp,2)+" down");
               if (trends[forBar][trendl3] != -1 && trends[forBar-1][trendl3] == -1) doAlert(time3,mess3,tfBar,"rsi "+timeFrameToString(timeFrame3)+" retraced from "+DoubleToStr(LevelDown,2)+" up");
            }
      }            

      //
      //
      //
      //
      //
      
      if (alertsOn50Align)
      {
         static datetime time4 = 0;
         static string   mess4 = "";
            for (int i=0; i<Bars; i++) if (arrowMidUp[i]!=EMPTY_VALUE || arrowMidDn[i]!=EMPTY_VALUE) break;
            if (arrowMidUp[i]!=EMPTY_VALUE) doAlert(time4,mess4,i,"3 time frames RSI are alligned up from "+TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
            if (arrowMidDn[i]!=EMPTY_VALUE) doAlert(time4,mess4,i,"3 time frames RSI are alligned downfrom "+TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert,  int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol(),timeFrameToString(Period())+" at ",TimeToStr(TimeLocal(),TIME_SECONDS)," rsi 3 time frames ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"rsi 3 time frames"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int getTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
      if (tfs=="C+1") return(nextTimeFrame(Period(),1));
      if (tfs=="C+2") return(nextTimeFrame(Period(),2));
      if (tfs=="C+3") return(nextTimeFrame(Period(),3));
      if (tfs=="C+4") return(nextTimeFrame(Period(),4));
                      return(stringToTimeFrame(tfs));  
}

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
int nextTimeFrame(int tf,int step)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i])
            if ((i+step)>=ArraySize(iTfTable))
                  return(iTfTable[i]);
            else  return(iTfTable[i+step]);
         return(0);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}